'*******************************************************************************
'
'Lasergamesystem mit ID-Protokoll (Nur ein Byte wird bermittelt). Die Gegner-
'namen sind im EEPROM jeder Waffe gespeichert.
'
'Noch dringend zu erledigen: single/burst, schussstrken-bermittlung
'
'*******************************************************************************

Dim A As Eram String * 8
Dim B As Eram String * 8
Dim C As Eram String * 8
Dim D As Eram String * 8
Dim E As Eram String * 8
Dim F As Eram String * 8
Dim G As Eram String * 8

Const Selfid = 8

Dim Feind As String * 8
Dim Hilf As String * 1
Dim Schaden As Byte
Dim Id As Byte
Dim Treffer As Bit
Dim Health As Byte
Dim Munition As Byte
Dim Ladevorgang As Bit
Dim Anzeige As Bit

Config Portd = Input
Config Portc = Output

Reactivation Alias Pinb.0
Magazin Alias Pinb.1

Config Timer0 = Timer , Prescale = 1024
Stop Timer0
Config Timer1 = Timer , Prescale = 1024
Stop Timer1
Config Int0 = Falling

Enable Interrupts
Enable Int0
Enable Timer0
Enable Timer1
On Int0 Schuss
On Timer0 Schussbereit
On Timer1 Nachladen_fertig

Feind = ""
Health = 100
Munition = 25
Ladevorgang = 0
Anzeige = 1

Cls
Lcd "Willkommen! Beim"
Lowerline
Lcd " Lasergame V1.0"

Wait 1
Cls

'*******************************************************************************

Main:

Treffer = 0

If Anzeige = 1 Then
   Anzeige = 0
   Gosub Anzeigen
End If

If Usr.rxc = 1 Then
   Id = Udr
   If Id <> Selfid Then Treffer = 1
End If

If Treffer = 1 Then
   Select Case Id
      Case 1 : Feind = A
      Case 2 : Feind = B
      Case 3 : Feind = C
      Case 4 : Feind = D
      Case 5 : Feind = E
      Case 6 : Feind = F
      Case 7 : Feind = G
      Case Else : Goto Main
   End Select
   Hilf = Mid(feind , 8 , 1)
   Schaden = Val(hilf)
   Health = Health - Schaden
   Feind = Mid(feind , 1 , 7)
   If Health < 1 Then Goto Tod
   Anzeige = 1
   Treffer = 0
End If

If Ladevorgang = 0 Then
   If Magazin = 1 Then
      Disable Int0
      Ladevorgang = 1
      Lowerline
      Lcd "**Lade-Vorgang**"
      Munition = 25
      Stop Timer0
      Start Timer1
   End If
End If

Goto Main

'*******************************************************************************

Schuss:
Disable Int0
Start Timer0
Anzeige = 1
If Munition > 0 Then
   Decr Munition
   Print Selfid
End If
Return

'*******************************************************************************

Tod:
Disable Int0
Stop Timer0
Stop Timer1
Cls
Lcd "Du bist Tod!"
Do
If Reactivation = 0 Then
   Cls
   Lcd "Re-Activation in"
   Lowerline
   Lcd "Progress........"
   Wait 2
   Health = 100
   Munition = 25
   Anzeige = 1
   Goto Main
End If
Loop

'*******************************************************************************

Schussbereit:
Enable Int0
Stop Timer0
Return

'*******************************************************************************

Anzeigen:
Home Upper
Lcd "Life:" ; Health ; "  "
If Feind <> "" Then
   Lowerline
   Lcd "Shoot by: " ; Feind
End If
If Munition < 1 Then
   Locate 1 , 10
   Lcd "NO AMMO"
Else
   Locate 1 , 10
   Lcd "Ammo:" ; Munition ; " "
End If
Anzeige = 0
Feind = ""

Select Case Health
   Case 0 : Portc = 0
   Case 1 To 12 : Portc = &B10000000
   Case 13 To 25 : Portc = &B11000000
   Case 26 To 38 : Portc = &B11100000
   Case 39 To 51 : Portc = &B11110000
   Case 52 To 64 : Portc = &B11111000
   Case 65 To 77 : Portc = &B11111100
   Case 78 To 90 : Portc = &B11111110
   Case 91 To 100 : Portc = &B11111111
End Select

Return

'*******************************************************************************

Nachladen_fertig:
Ladevorgang = 0
Stop Timer1
Enable Int0
Cls
Anzeige = 1
Return

'*******************************************************************************

End                                                         'end program